## opusenc opusenc |

## Properties

gboolean | audio | Read / Write
GstOpusEncAudioType | audio-type | Read / Write
GstOpusEncBandwidth | bandwidth | Read / Write
gint | bitrate | Read / Write
GstOpusEncBitrateType | bitrate-type | Read / Write
gboolean | cbr | Read / Write
gint | complexity | Read / Write
gboolean | constrained-vbr | Read / Write
gboolean | dtx | Read / Write
GstOpusEncFrameSize | frame-size | Read / Write
gboolean | inband-fec | Read / Write
guint | max-payload-size | Read / Write
gint | packet-loss-percentage | Read / Write

## Types and Values

struct | GstOpusEnc
enum | GstOpusEncBitrateType

## Object Hierarchy

        GObject
        ╰── GInitiallyUnowned
            ╰── GstObject
                ╰── GstElement
                    ╰── GstAudioEncoder
                        ╰── GstOpusEnc

## Implemented Interfaces

GstOpusEnc implements GstPreset and GstTagSetter.

## Description

This element encodes raw audio to OPUS.

### Example pipelines

    1
    gst-launch-1.0 -v audiotestsrc wave=sine num-buffers=100 ! audioconvert ! opusenc ! oggmux ! filesink location=sine.ogg

Encode a test sine signal to Ogg/OPUS.

## Synopsis

### Element Information

plugin | opus
author | Vincent Penquerc'h <vincent.penquerch@collabora.co.uk>
class | Codec/Encoder/Audio

### Element Pads

name | sink
direction | sink
presence | always
details | audio/x-raw, format=(string)S16LE, layout=(string)interleaved, rate=(int)48000, channels=(int)[ 1, 8 ]
| audio/x-raw, format=(string)S16LE, layout=(string)interleaved, rate=(int){ 8000, 12000, 16000, 24000 }, channels=(int)[ 1, 8 ]

name | src
direction | source
presence | always
details | audio/x-opus

## Functions

## Types and Values

### struct GstOpusEnc

    struct GstOpusEnc;

### enum GstOpusEncBitrateType

#### Members

BITRATE_TYPE_CBR |  |
BITRATE_TYPE_VBR |  |
BITRATE_TYPE_CONSTRAINED_VBR |  |

## Property Details

### The `“audio”` property

      “audio”                    gboolean

Audio or voice (DEPRECATED: use audio-type).

Flags: Read / Write

Default value: TRUE

### The `“audio-type”` property

      “audio-type”               GstOpusEncAudioType

What type of audio to optimize for.

Flags: Read / Write

Default value: Generic audio

### The `“bandwidth”` property

      “bandwidth”                GstOpusEncBandwidth

Audio Band Width.

Flags: Read / Write

Default value: Full band

### The `“bitrate”` property

      “bitrate”                  gint

Specify an encoding bit-rate (in bps).

Flags: Read / Write

Allowed values: [4000,650000]

Default value: 64000

### The `“bitrate-type”` property

      “bitrate-type”             GstOpusEncBitrateType

Bitrate type.

Flags: Read / Write

Default value: CBR

### The `“cbr”` property

      “cbr”                      gboolean

Constant bit rate (DEPRECATED: use bitrate-type).

Flags: Read / Write

Default value: TRUE

### The `“complexity”` property

      “complexity”               gint

Complexity.

Flags: Read / Write

Allowed values: [0,10]

Default value: 10

### The `“constrained-vbr”` property

      “constrained-vbr”          gboolean

Constrained VBR (DEPRECATED: use bitrate-type).

Flags: Read / Write

Default value: TRUE

### The `“dtx”` property

      “dtx”                      gboolean

DTX.

Flags: Read / Write

Default value: FALSE

### The `“frame-size”` property

      “frame-size”               GstOpusEncFrameSize

The duration of an audio frame, in ms.

Flags: Read / Write

Default value: 20

### The `“inband-fec”` property

      “inband-fec”               gboolean

Enable forward error correction.

Flags: Read / Write

Default value: FALSE

### The `“max-payload-size”` property

      “max-payload-size”         guint

Maximum payload size in bytes.

Flags: Read / Write

Allowed values: [2,4000]

Default value: 4000

### The `“packet-loss-percentage”` property

      “packet-loss-percentage”   gint

Packet loss percentage.

Flags: Read / Write

Allowed values: [0,100]

Default value: 0

## See Also

opusdec, oggmux